from setuptools import setup, find_packages
from os.path import join, dirname

setup(
   name='uzoenr',
   version='21.0.0.1',
   url='https://notabug.org/montarakuono/uzoenr',
   author='Montara Kuono',
   author_email='montarakuono@jungle.tes',
   packages=["uzoenr"],
   license='GNU GPL3+',
   description='The best text web browser',
   long_description=open('README.md').read(),
   install_requires=[
       "requests>=2.22.0",
       "pymorphy2>=0.9.1",
   ],
   classifiers=[
        "Programming Language :: Python :: 3",
        "License :: OSI Approved :: GNU General Public License v3 or later (GPLv3+)",
        "Operating System :: POSIX :: Linux",
        "Topic :: Internet :: WWW/HTTP :: Browsers"
    ],
   entry_points={
        'console_scripts':
            ['uzoenr = uzoenr.uzoenr:start',
            'hundo = uzoenr.sync:sync',
            'aquila = uzoenr.aquila:start']
        }
)
