from html.parser import HTMLParser

class Engine(HTMLParser):
    """ HTML parsing engine. Use feed method to generate a text from your web page. """
    data = ""
    permit = False
    def handle_starttag(self, tag, attrs):
        self.permit = (lambda tag: tag not in ["style", 'script'] or tag in ["a", "form", "input"])(tag)
        if tag == 'a':
           try:
               url = dict(attrs)["href"]
               self.data = self.data + "<" + url + " "
           except:
               pass
        elif tag == "table":
            self.data = self.data + "\n\n"
        elif tag == "form":
            try:
                url = dict(attrs)["action"]
                met = dict(attrs)["method"]
                self.data = self.data + "\n[[FORM "+url+' '+met+'\n'
            except:
                pass
        elif tag == "input":
            try:
                name = dict(attrs)["name"]
                self.data = self.data + "(INPUT "+name+")\n"
            except KeyError:
                try:
                    tp = dict(attrs)['type']
                    if tp=='submit':
                        self.data = self.data + "(INPUT =OK=)\n"
                except:
                    pass
        elif tag == "img":
            try:
                name = dict(attrs)["alt"]
            except:
                name = ""
            try:
                uri = dict(attrs)["src"]
            except:
                uri = "?!?!"
            self.data = self.data + f"\n<<{uri}]IMG {name}>>\n"
    def handle_endtag(self, tag):
        if tag == "a":
            self.data = self.data + "///>"
        elif tag in ["br", "li"]:
            self.data = self.data + "\n\n"
        elif tag == "form":
            self.data = self.data + "]]\n"
        elif tag == "td":
            self.data = self.data + "\t\t"
        elif tag == "tr":
            self.data = self.data + "\n"
        elif tag == "table":
            self.data = self.data + "\n\n"
        elif tag == "li":
            self.data = self.data + "\n"
    def handle_data(self, data):
        if self.permit:
            self.data = self.data + data


class Akela(HTMLParser):
    """ Class of HTML to plaintext convertor. Use a feed meth
od to generate a text."""
    book = ""
    permit = True
    bd = False
    def handle_starttag(self, tag, attrs):
        if tag == 'body':
            self.bd = True
        self.permit = (lambda tag: tag not in ["style", 'script'])(tag)
    def handle_endtag(self, tag):
        if tag in ["br", "li", 'table']:
            self.data = self.data + "\n\n"
        elif tag == "td":
            self.data = self.data + "\t\t"
        elif tag == "tr":
            self.data = self.data + "\n"
        elif tag == 'body':
            self.bd = False
    def handle_data(self, data):
        if self.bd and self.permit:
            self.data = self.data + data
